<?php
error_reporting(E_ALL ^ E_WARNING ^ E_NOTICE);
include "fefunctions.php";
include "iocommand.php";
start_session();
?>
<html>
<head>
<title>HP Insight Diagnostics</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
</head>

<body onLoad="setTimeout('nextPage()', 1000)">
<?php 
  $pid = $_REQUEST["pid"];

  $idErrors = "";
  $idStatus = "";
  $statusCommand = sprintf("<getProcessStatus processID='%s' />", $pid);

  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $statusCommand, $idStatus, $idErrors);
  $xmldoc = new DomDocument($idStatus);
  $rootElement = $xmldoc->document_element();
  
  // check if error was returned
  if ($rootElement->tagname == "error")
  {
    printf("<script language='Javascript'>\nalert('" . $rootElement->get_content() . "');\nparent.window.close();\n</script>\n");
  }
  
  // get percent completion - set to 0 if empty
  $percentComplete = $rootElement->get_attribute("percentComplete");
  if (strlen($percentComplete) == 0) // if empty
    $percentComplete = 0; // set to zero

  // get the state
  $state = $rootElement->get_attribute("state");

  // see if process is running
  $stillRunning = false;
  if ($state == "running" || $state == "submitted" || $state == "canceling")
    $stillRunning = true;

  // see if process completed normally
  $completedNormally = false;
  if ($state == "completed" && $percentComplete == "100")
    $completedNormally = true;

  if (!$stillRunning)
  {
    // not still running... get the result
    // if it did not complete normally, add the "leaveProcessInfo" attribute
    // so that the AI will keep its processinfo for debugging
    if ($completedNormally)
      $resultCommand = sprintf("<getProcessResult processID='%s' />", $pid);
    else
      $resultCommand = sprintf("<getProcessResult processID='%s' leaveProcessInfo='1' />", $pid);
    ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $resultCommand, $_SESSION["idResult"], $idErrors);
  }
  
  printf("<script language=Javascript>\n");

  printf("function nextPage(){\n");
  printf("parent.frames.idstatus.document.getElementById(\"overallPercent\").style.width = \"%d%%\";\n", $percentComplete);
  printf("parent.frames.idstatus.document.getElementById(\"overallPercent\").innerHTML = \"%d%%\";\n", $percentComplete);

  if ($stillRunning)
  {
    // still running... reload page
    if ($_REQUEST["cfg"] == "1")
      printf("window.location = 'updateidstatus.php?pid=%s&cfg=1';", $pid);
    else
      printf("window.location = 'updateidstatus.php?pid=%s';", $pid);
  }
  else if ($completedNormally)
  {
    // completed normally... proceed to next page
    //printf("document.onkeydown = keyHit;");
    if ($_REQUEST["cfg"] == "1" || checkDiagConfig("/factory/configVerify"))
      printf("window.parent.location = 'configverifyform.php?pid=%s';", $pid);
    else
    	printf("window.parent.location = 'hpdiags.php?pid=%s';", $pid);  
  }
  else
  {
    // not running but also not completed normally... abnormal termination message
    // look for an err element in the result
    $alertMessage = TR("MSG_ABNORMAL_TERMINATION") . ", state: " . $state;
    $idXml = @new DomDocument($_SESSION["idResult"]);
    $idXpath = @xpath_new_context($idXml->document_element());
    $errors = @xpath_eval($idXpath, "/error");
    foreach ($errors->nodeset as $errorNode)
    {
      $alertMessage = $alertMessage . ", " . $errorNode->get_content();
    }
    printf("alert('%s');\n", $alertMessage);
  }

  printf("}\n");

  if ($completedNormally && ($_REQUEST["cfg"] == "1" || checkDiagConfig("/factory/configVerify")))
    printf("parent.frames.idstatus.document.getElementById(\"loading\").innerHTML = \"<font size='3' color='#000000' face='helvetica'>%s %s. <br><br>%s ...Running config verification.\";\n", TR("MSG_LOADING"),TR("MSG_HP_INSIGHT_DIAGNOSTICS"),TR("MSG_PLEASE_WAIT"));
  else
    printf("parent.frames.idstatus.document.getElementById(\"loading\").innerHTML = \"<font size='3' color='#000000' face='helvetica'>%s %s. <br><br>%s ...%s.\";\n", TR("MSG_LOADING"),TR("MSG_HP_INSIGHT_DIAGNOSTICS"),TR("MSG_PLEASE_WAIT"), TR("MSG_SCANNING_HARDWARE"));

  printf("</script>");  
  
?>

